print_newline() ;;
print_newline() ;;
print_string 
     `You are about to load UNITY logic for HOL theorem prover.` ;;
print_newline() ;;
print_string 
     `Author: Wishnu Prasetya` ;;
print_newline() ;;
print_newline() ;;

loadf `predicate` ;;

let this_lib_name = `UU_UNITY`
and parent_libs = []
and theories = [`leadsto`;`ensures`;`unless`;`def_UNITY`;`TDC`;
                `WF`;`variables`;`relation`]
and codes = []
and load_parent = ``
and part_path = ``
and help_paths = []
in
library_loader (this_lib_name, parent_libs, theories, codes,
 load_parent, part_path, help_paths);;

let State = ":*var->*value" ;;
let Pred = ":(*var->*value)->bool" ;;
let Action = ":(*var->*value)->(*var->*value)->bool" ;;
let ACTIONS = ":((*var->*value)->(*var->*value)->bool)->bool" ;;
let VARS = ":*var->bool" ;;
let Uprog = ":^ACTIONS # ^Pred # ^VARS # ^VARS" ;;

let CONF_qOR_thm = 
    GEN_ALL
    (BETA_RULE (ISPECL ["V:^VARS"; "W:^Pred->bool"; "\p:^Pred. p"] CONF_qOR)) ;;

let CONF_qAND_thm = 
    GEN_ALL
    (BETA_RULE (ISPECL ["V:^VARS"; "W:^Pred->bool"; "\p:^Pred. p"] CONF_qAND)) ;;

letrec CONF_TAC n = 
    if (n=0) then ALL_TAC
    else (((MATCH_MP_TAC CONF_NOT ORELSE
           MATCH_MP_TAC CONF_OR ORELSE
           MATCH_MP_TAC CONF_AND ORELSE
           MATCH_MP_TAC CONF_IMP ORELSE
           MATCH_MP_TAC CONF_qAND ORELSE
           MATCH_MP_TAC CONF_qAND_thm ORELSE
           MATCH_MP_TAC CONF_qOR ORELSE
           MATCH_MP_TAC CONF_qOR_thm ORELSE
           REWRITE_TAC[CONF_TT;CONF_FF])
           ? ALL_TAC)
           THEN REPEAT STRIP_TAC
           THEN ASM_REWRITE_TAC[]
           THEN CONF_TAC (n-1)) ;;

letrec LocPred_TAC n = 
    if (n=0) then ALL_TAC
    else (((MATCH_MP_TAC LocPred_NOT ORELSE
           MATCH_MP_TAC LocPred_OR ORELSE
           MATCH_MP_TAC LocPred_AND ORELSE
           MATCH_MP_TAC LocPred_IMP ORELSE
           MATCH_MP_TAC LocPred_qAND ORELSE
           MATCH_MP_TAC LocPred_GEN_qAND ORELSE
           MATCH_MP_TAC LocPred_qOR ORELSE
           MATCH_MP_TAC LocPred_GEN_qOR ORELSE 
           REWRITE_TAC[LocPred_TT;LocPred_FF])
           ? ALL_TAC)
           THEN REPEAT STRIP_TAC
           THEN ASM_REWRITE_TAC[]
           THEN LocPred_TAC (n-1)) ;;

let REDUCE_UNLESS_TAC =
    REWRITE_TAC [UNLESS; HOA_DEF] THEN pred_JADE_TAC 0 ;;

let ENSURES_TAC =
    RESTRICT_DEF_TAC
    THEN REWRITE_TAC [ENSURES] THEN REPEAT STRIP_TAC  
    THEN ASM_REWRITE_TAC[] ;;

let HOA_TAC =
  XRULE_ASSUM_TAC RESTRICT_DEF_RULE
  THEN RESTRICT_DEF_TAC
  THEN UNDISCH_ALL_TAC 
  THEN REWRITE_TAC [HOA_DEF] THEN REPEAT STRIP_TAC ;;

let LEADSTO_INDUCT1_TAC = 
   REPEAT GEN_TAC
   THEN MATCH_MP_TAC LEADSTO_INDUCT_thm1
   THEN REWRITE_TAC [SUBREL; Loc_ENS; TRANS_DEF; LDISJ_DEF]
   THEN BETA_TAC 
   THEN REPEAT STRIP_TAC ;;

let LEADSTO_INDUCT2_TAC = 
   REPEAT GEN_TAC
   THEN MATCH_MP_TAC LEADSTO_INDUCT_thm2
   THEN REWRITE_TAC [SUBREL; Loc_ENS; Ri_TR_DEF; LDISJ_DEF]
   THEN BETA_TAC 
   THEN REPEAT STRIP_TAC ;;

let LEADSTO_INDUCT3_TAC = 
   REPEAT GEN_TAC
   THEN MATCH_MP_TAC LEADSTO_INDUCT_thm3
   THEN REWRITE_TAC [SUBREL; Loc_ENS; TRANS_DEF; LDISJ_DEF; rINTER]
   THEN BETA_TAC 
   THEN REPEAT STRIP_TAC 
   THENL [ IMP_RES_TAC (QUAFF_RULE 3 LEADSTO_ENS_LIFT) ; ALL_TAC ;
           IMP_RES_TAC LEADSTO_TRANS ; ALL_TAC ;
           MATCH_MP_TAC LEADSTO_DISJ 
           THEN ASM_REWRITE_TAC [Non_FF_lemma]
           THEN CONJ_TAC
           THENL [ EXISTS_TAC "x:^Pred" THEN ASM_REWRITE_TAC[] ;
                   UNDISCH_ALL_TAC
                   THEN RESTRICT_DEF_TAC
                   THEN REPEAT STRIP_TAC THEN RES_TAC ] ;
           ALL_TAC] ;;

let LT_DOUBLE_INDUCT_TAC = 
   REPEAT GEN_TAC
   THEN MATCH_MP_TAC LT_DOUBLE_INDUCT
   THEN REWRITE_TAC [Loc_ENS]
   THEN BETA_TAC 
   THEN REPEAT STRIP_TAC ;;

print_newline() ;;
print_newline() ;;
print_string `Loading Attempt COMPLETED` ;; 
print_newline() ;;


