let State   = ":*var -> *value" ;;
let Pred    = ":^State -> bool" ;;
let VARS    = ":*var -> bool" ;;
let Action  = ":^State -> ^State -> bool" ;;
let ACTIONS = ":^Action -> bool" ;;
let Uprog   = ":^ACTIONS # ^Pred # ^VARS # ^VARS" ;;


loadf `predicate` ;;
loadf `OLD_RES` ;;
let MYautoload thy = 
    let defs = map fst (definitions thy) in
    map (\name. autoload_theory(`definition`,thy,name)) defs;
    let thms = map fst (theorems thy) in
    map (\name. autoload_theory(`theorem`,thy,name)) thms; 
    delete_cache thy; ();;

print_newline() ;;
print_string `Now attempting to load U3_COMP Library` ;;
print_newline() ;;

if draft_mode() 
   then ( new_parent `U3_COMP` ; 
          print_string `U3_COMP declared as new parent` ;
          print_newline())
   else ( load_theory `U3_COMP`;
          print_string `U3_COMP is loaded` ;
          print_newline()) ;;

MYautoload `WF` ;
MYautoload `def_UNITY` ;
MYautoload `unless` ;
MYautoload `ensures` ;
MYautoload `leadsto` ;
delete_cache `leadsto` ;
MYautoload `U3_COMP` ;;
loadf `U3_SUP` ;

print_string `U3_COMP is set for autoload` ;
print_newline() ;
print_newline() ;
print_string `Library U3_COMP is loaded!` ; print_newline() ;
print_string `U3_COMP: Compositionality in UNITY` ; print_newline() ;
print_string `written by Wishnu Prasetya` ; print_newline() ;
print_string `Utrecht University, 1993` ; print_newline() ;
print_newline() ;;
