let thy = `def_UNITY` ;;

let my_path = `/infix/5s0/wishnu/testhol` 

 in
set_search_path (union (search_path()) [my_path ^ `/` ^ thy ^ `/`]);;
print_string `(1) search path updated`;; print_newline();;

if draft_mode() 
   then new_parent thy else load_theory thy;;

if draft_mode()
   then (print_string (`(2) ` ^ thy ^ ` declared as new parent`) ;
         print_newline())
   else (if ((current_theory() = thy))
         then (print_string (`(2) theory ` ^ thy ^ ` loaded`) ;
               print_newline())
         else (print_string (`Fail to load theory ` ^ thy ^ ` predicate!!`) ;
               print_newline())) ;;

if (draft_mode() or (current_theory() = thy)) then
   let defs = map fst (definitions thy) in
       map (\name. autoload_theory(`definition`,thy,name)) defs;
   let thms = map fst (theorems thy) in
       map (\name. autoload_theory(`theorem`,thy,name)) thms; 
   delete_cache thy; ();;


